#ifndef __RR_GSOAP_H__
#define __RR_GSOAP_H__

typedef struct _RRGSOAP RRGSOAP;
typedef struct _RRGSOAPPriv RRGSOAPPriv;
typedef struct _RRGSOAPClass RRGSOAPClass;

#include <librr/rr-channel.h>

G_BEGIN_DECLS

#define RR_TYPE_GSOAP (rr_gsoap_get_type ())
#define RR_GSOAP(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj), RR_TYPE_GSOAP, RRGSOAP))
#define RR_GSOAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RR_TYPE_GSOAP, RRGSOAPClass))
#define RR_IS_GSOAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj), RR_TYPE_GSOAP))
#define RR_IS_GSOAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RR_TYPE_GSOAP))
#define RR_GSOAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RR_TYPE_GSOAP, RRGSOAPClass))

struct _RRGSOAP {
	RRChannel parent_object;
	RRGSOAPPriv *priv;
};

struct _RRGSOAPClass {
	RRChannelClass parent_class;
	/* reserved for future use */
	void (* rr_padding1)  (void);
	void (* rr_padding2)  (void);
	void (* rr_padding3)  (void);
	void (* rr_padding4)  (void);
	void (* rr_padding5)  (void);
	void (* rr_padding6)  (void);
	void (* rr_padding7)  (void);
	void (* rr_padding8)  (void);
	void (* rr_padding9)  (void);
	void (* rr_padding10) (void);
};

GType rr_gsoap_get_type (void);

gboolean rr_gsoap_close  (RRGSOAP *soap, GError **error);
RRGSOAP *rr_gsoap_start (RRConnection *connection, const gchar *server_name,
		const gchar *resource, GError **error);
int rr_gsoap_send (RRGSOAP *soap, const char *buf, size_t len);
size_t rr_gsoap_recv (RRGSOAP *soap, char *buf, size_t len);

#define RR_GSOAP_ERROR (rr_gsoap_error_quark ())
GQuark         rr_gsoap_error_quark       (void);

G_END_DECLS

#endif /* __RR_GSOAP_H__ */
