#include "soapH.h"
#include "plugin.h"
#include "calc.nsmap"

const char server[] = "soap.beep://gurke.gaertner.de:10289";
//const char server[] = "http://gurke.gaertner.de/cgi-bin/calcserver";

int main(int argc, char **argv)
{ struct soap soap,*soap2;
  double a, b, result;
  int count = 0;
  if (argc < 4)
  { fprintf(stderr, "Usage: [add|sub|mul|div|pow] num num\n");
    exit(0);
  }
  soap_init(&soap);
  beep_init();
  soap_register_plugin(&soap, plugin); // register plugin
  a = strtod(argv[2], NULL);
  b = strtod(argv[3], NULL);
  while(1) {
    switch (*argv[1])
    { case 'a':
	soap_call_ns__add(&soap, server, "", a, b, &result);
	soap.keep_alive = 1;
	break;
      case 's':
	soap_call_ns__sub(&soap, server, "", a, b, &result);
	break;
      case 'm':
	soap_call_ns__mul(&soap, server, "", a, b, &result);
	break;
      case 'd':
	soap_call_ns__div(&soap, server, "", a, b, &result);
	break;
      case 'p':
	soap_call_ns__pow(&soap, server, "", a, b, &result);
	break;
      default:
	fprintf(stderr, "Unknown command\n");
	exit(0);
    }
    if (soap.error) {
      soap_print_fault(&soap, stderr);
    }
    else
      printf("%d. result = %g %d\n", ++count, result, soap.keep_alive);
  }
  soap_call_ns__add(&soap, "peer", "", a, b, &result);
  printf("result = %g\n", result);
  soap2 = soap_copy(&soap);
  soap_call_ns__add(soap2, "peer", "", a, b, &result);
  printf("result = %g\n", result);
  soap_end(&soap);
  soap_end(soap2);
  soap_done(soap2);
  soap_done(&soap);
  return 0;
}
