/*	plugin.h

	Example gSOAP plug-in

	Copyright (C) 2000-2002 Robert A. van Engelen. All Rights Reserved.

*/

#include "stdsoap2.h"
#include <librr/rr.h>
#include "rrplugin.h"

#define PLUGIN_ID "SOAP-BEEP" /* plugin identification */
#define MAX_SERVERS 8
#define HOSTNAMELEN 255

struct plugin_data
{ int (*fsend)(struct soap*, const char*, size_t); /* example: to save and use send callback */
  size_t (*frecv)(struct soap*, char*, size_t); /* example: to save and use recv callback */
  int (*fpost)(struct soap*, const char*, const char*, int, const char*, const char*, size_t);
  int (*fopen)(struct soap*, const char*, const char*, int);
  int (*fclose)(struct soap*);
  int (*fpoll)(struct soap*);
  int (*faccept)(struct soap*, int, struct sockaddr*, int*);
  int (*soap_serve_callback)(struct soap *soap);
  int (*fresponse)(struct soap*, int, size_t);
  RRConnection *connection;
  RRProfileRegistry *profreg;
  RRGSOAP *rrsoap;
  int 	 bypass;
  int    initiator;
};

typedef struct _server_list
{
  char host[HOSTNAMELEN];
  int port;
} server_list;

int plugin(struct soap *soap, struct soap_plugin *plugin, void *arg);
int rr_plugin_start_server(int(*soap_serve_callback)(struct soap *soap), const char* hostname, int port);
int rr_register_callback (struct soap *soap, int (*soap_serve_callback) (struct soap *soap));
int plugin_soap_serve(RRGSOAP *rrsoap, struct soap *soap);
